<template>
  <div class="table-container">
    <!-- <vab-page-header description="功能强大的数据表格组件，支持排序、分页、搜索等功能" :icon="['fas', 'table']" title="表格管理" /> -->
    <!-- <vab-query-form> -->
    
       <el-col>
      <el-row style="display: flex;align-items: center;">
  
     <el-form ref="form" :inline="true" :model="queryForm" @submit.native.prevent>
         <vab-query-form-left-panel style="width:130px;">
        <el-button  icon="el-icon-delete" type="primary" @click="handleDelete">导出</el-button> 
      </vab-query-form-left-panel>
       <el-form-item label="查询时间"  style="margin-right:40px;">
            <el-date-picker
               v-model="queryForm.time"
                 unlink-panels
                value-format="yyyy-MM-dd"
               type="daterange"
               range-separator="-"
               start-placeholder="开始日期"
               end-placeholder="结束日期"
                :picker-options="pickerOptions"
            ></el-date-picker>
         </el-form-item>
           <!-- <el-form-item label="订单状态"  style="margin-right:40px;">
    <el-select v-model="queryForm.id" placeholder="请选择活动区域">
      <el-option label="未支付" value="1"></el-option>
      <el-option label="已支付" value="2"></el-option>
      <el-option label="已派单" value="3"></el-option>
      <el-option label="服务中" value="4"></el-option>
      <el-option label="已完成" value="5"></el-option>
      <el-option label="已取消" value="6"></el-option>
    </el-select>
  </el-form-item> -->
   <el-form-item>
            <el-input v-model="queryForm.status_Inquiry" placeholder="输入手机号或订单号查询" />
          </el-form-item>
          <el-form-item>
            <el-button icon="el-icon-search" native-type="submit" type="primary" @click="handleQuery">查询</el-button>
          </el-form-item>
        </el-form>
        </el-row>
  </el-col>
      
        <!-- <el-button type="primary" @click="testMessage">baseMessage</el-button>
        <el-button type="primary" @click="testALert">baseAlert</el-button>
        <el-button type="primary" @click="testConfirm">baseConfirm</el-button>
        <el-button type="primary" @click="testNotify">baseNotify</el-button> -->
      <!-- <vab-query-form-right-panel>
      </vab-query-form-right-panel> -->
    <!-- </vab-query-form> -->

    <el-table
      ref="tableSort"
      v-loading="listLoading"
      :data="list"
      :element-loading-text="elementLoadingText"
      :height="height"
      @selection-change="setSelectRows"
      @sort-change="tableSortChange"
    >
      <!-- <el-table-column  type="selection" width="55" /> -->
      <!-- <el-table-column label="序号"  width="95">
        <template #default="scope">
          {{ scope.$index + 1 }}
        </template>
      </el-table-column> -->
      <el-table-column align="center" width="180" label="创建时间" prop="创建时间"  />
      <el-table-column align="center" width="250" label="地址" prop="地址"  />
      <el-table-column align="center" width="120" label="小哇名字" prop="小哇名字"  />
      <el-table-column align="center" width="120" label="宠物名称" prop="宠物名称"  />
      <el-table-column align="center" width="180" label="订单电话" prop="订单电话"  />
      <el-table-column align="center" width="180" label="用户电话" prop="用户电话"  />
      <el-table-column align="center" width="180" label="支付时间" prop="支付时间"  />
      <el-table-column align="center" width="180" label="订单创建时间" prop="订单创建时间"  />
      <el-table-column align="center" width="180" label="订单取消时间" prop="订单取消时间"  />
      <el-table-column align="center" width="100" label="服务价格" prop="服务价格"  />
      <el-table-column align="center" width="200" label="服务名称" prop="服务名称"  />
      <el-table-column align="center" width="100" label="服务日期" prop="服务日期"  />
      <el-table-column align="center" width="200" label="服务时段" prop="服务时段"  />
      <el-table-column align="center" width="100" label="服务类型" prop="服务类型"  />
      <el-table-column align="center" width="120" label="用户ID" prop="用户ID"  />
      <el-table-column align="center" label="订单ID" prop="订单ID"  />
      <el-table-column align="center" width="200" label="订单号" prop="订单号"  />
      <el-table-column align="center" label="订单状态" prop="订单状态"  />
      <el-table-column align="center" label="订单类型" prop="订单类型"  />
      <!-- <el-table-column label="头像" >
        <template #default="{ row }">
          <el-image v-if="imgShow" :preview-src-list="imageList" :src="row.img" />
        </template>
      </el-table-column> -->
      <!-- <el-table-column label="点击量" prop="pageViews"  sortable /> -->
      <!-- <el-table-column label="状态" >
        <template #default="{ row }">
          <el-tooltip class="item" :content="row.status" effect="dark" placement="top-start">
            <el-tag :type="row.status | statusFilter">
              {{ row.status }}
            </el-tag>
          </el-tooltip>
        </template>
      </el-table-column> -->
      <!-- <el-table-column label="时间" prop="datetime"  width="200" /> -->
      <el-table-column label="操作"  fixed="right" width="60px">
        <template #default="{ row }">
          <el-button v-if="row.订单状态 == '2' || row.订单状态 == '3'  " type="text" @click="handleEdit(row)">编辑</el-button>
          <!-- <el-button type="text" @click="handleDelete(row)">删除</el-button> -->
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :background="background"
      :current-page="queryForm.pageNo"
      :layout="layout"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
    <table-edit ref="edit" />
  </div>
</template>

<script>
  import { doDelete, getdoorList,expordoortodoorOrdern } from '@/api/table'
  import TableEdit from './components/TableEdit'
  import VabPageHeader from '@/components/VabPageHeader'

  export default {
    name: 'ComprehensiveTable',
    components: {
      TableEdit,
      VabPageHeader,
    },
    filters: {
      statusFilter(status) {
        const statusMap = {
          published: 'success',
          draft: 'gray',
          deleted: 'danger',
        }
        return statusMap[status]
      },
    },
    data() {
      return {
          pickerOptions: {
          shortcuts: [{
            text: '最近一周',
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit('pick', [start, end]);
            }
          }, {
            text: '最近一个月',
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit('pick', [start, end]);
            }
          }, {
            text: '最近三个月',
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit('pick', [start, end]);
            }
          }]
        },
        imgShow: true,
        list: [],
        imageList: [],
        listLoading: true,
        layout: 'total, sizes, prev, pager, next, jumper',
        total: 0,
        background: true,
        selectRows: '',
        elementLoadingText: '正在加载...',
        queryForm: {
          pageNo: 1,
          pageSize: 20,
          title: '',
        },
        timeOutID: null,
      }
    },
    computed: {
      height() {
        return this.$baseTableHeight()
      },
    },
    created() {
      this.fetchData()
    },
    beforeDestroy() {
      clearTimeout(this.timeOutID)
    },
    mounted() {},
    methods: {
      tableSortChange() {
        const imageList = []
        this.$refs.tableSort.tableData.forEach((item, index) => {
          imageList.push(item.img)
        })
        this.imageList = imageList
      },
      setSelectRows(val) {
        this.selectRows = val
      },
      handleAdd() {
        this.$refs['edit'].showEdit()
      },
      handleEdit(row) {
        // console.log(row,'---')
        this.$refs['edit'].showEdit(row)
      },
      handleDelete() {
        expordoortodoorOrdern().then(
  response => {
     window.location.href = response.data.url;  
  }
).catch(error => {
  console.error('下载失败', error)
  this.loading = false // 停止加载，隐藏加载状态
})
      },
      handleSizeChange(val) {
        this.queryForm.pageSize = val
        this.fetchData()
      },
      handleCurrentChange(val) {
        this.queryForm.pageNo = val
        this.fetchData()
      },
      handleQuery() {
        this.queryForm.pageNo = 1
        this.fetchData()
      },
      async fetchData() {
        this.listLoading = true
        const { data, total } = await getdoorList(this.queryForm)
        this.list = data
        const imageList = []
        data.forEach((item, index) => {
          imageList.push(item.img)
        })
        this.imageList = imageList
        this.total = total
        this.timeOutID = setTimeout(() => {
          this.listLoading = false
        }, 500)
      },
      testMessage() {
        this.$baseMessage('test1', 'success')
      },
      testALert() {
        this.$baseAlert('11')
        this.$baseAlert('11', '自定义标题', () => {
          /* 可以写回调; */
        })
        this.$baseAlert('11', null, () => {
          /* 可以写回调; */
        })
      },
      testConfirm() {
        this.$baseConfirm(
          '你确定要执行该操作?',
          null,
          () => {
            /* 可以写回调; */
          },
          () => {
            /* 可以写回调; */
          }
        )
      },
      testNotify() {
        this.$baseNotify('测试消息提示', 'test', 'success', 'bottom-right')
      },
    },
  }
</script>
